<template>
  <footer :class="['WaFooter', theme]">
    <!--
      Variants
      blue-logo -> set the backgroundColor blue with text white
    -->

    <!-- 
      1.Ho convertito l'Option API in Composition API
      2.Ho sostituito il mixin che si occupava del check sulle slots con delle computed 
      3. Ho sostituito il controllo sugli step responsive del plugin vue-viewport-manager non compatibile con la versione 3 di vue, con una composition function useViewportManager;  [- Naming convention per le composition functions è quella di usare useNomeFunzione -]
      4. Ho sostituito il mixin language-support con una composition function per renderizzare la lingua. L'utlizzo della composition function rispetto ad un mixin rende molto più facilmente leggibile il codice in quanto importo esattamente le proprietà che  uso nel template.
    -->
    <div :class="['container-fluid', dataTopSpacing, dataBottomSpacing]">
      <div class="row">
        <div class="col-12">
          <!-- TopFooter -->
          <div class="row topFooter">
            <nav 
              v-if="showColumns" 
              class="col-12 col-md-9 navigationColumns"
            >
              <div class="row">
                <slot name="columns" />
              </div>
            </nav>
            <div
              v-if="['md', 'lg'].includes(step)"
              class="col-md-3 d-flex justify-content-md-end"
            >
              <div 
                class="navbarLanguage typo-a-9" 
                @click.prevent="onBtnLangClick"
              >
                <a class="currentLangItem" href="#">
                  {{ currentCountry }} ({{ currentLang }})
                </a>
                <svg width="24" height="24">
                  <use href="#icon-world" fill="currentColor" />
                </svg>
              </div>
            </div>
          </div>
          <!-- end TopFooter -->
          <!-- BottomFooter -->
          <div class="bottomFooter">
            <div 
              v-if="['xs', 'sm'].includes(step)" 
              class="navbarLanguage typo-a-9"
            >
              <a class="currentLangItem" @click.prevent="onBtnLangClick">
                {{ currentCountry }} ({{ currentLang }})
              </a>
              <svg width="24" height="24">
                <use href="#icon-world" fill="currentColor" />
              </svg>
            </div>
            <slot name="wa-social-share" />
            <div 
              v-if="showLegalText" 
              class="copyrightFooter"
            >
              <slot name="legalText" />
            </div>
          </div>
          <!-- end BottomFooter -->
        </div>
      </div>
    </div>
  </footer>
</template>

<script>
import { computed, Comment } from "vue";

//importo la funzione useStore per poter accedere allo store
import { useStore } from "vuex";

//importo la composition function useLanguageSupport per renderizzare correttamente la label della lingua
import useLanguageSupport from "../hooks/useLanguageSupport";

//importo la composition function useViewportManager per gestire gli step responsive
import useViewportManager from "../hooks/useViewportManager.js";

export default {
  name: "WaFooter",
  //mixins: [LanguageSupport],
  props: {
    dataTopSpacing: {
      type: String,
      default: "padding-top-l"
    },
    dataBottomSpacing: {
      type: String,
      default: "padding-bottom-l"
    },
  },
  setup(_, context) {
    //importo la proprietà esposta dalla function per poterla usare nel componente
    const { step } = useViewportManager();
    const store = useStore();
    const theme = computed(() => {
      return store.state.config.inverted_footer ? "bg-color-blue-logo" : "light";
    });
    //importo le proprietà esposta dalla composition function per poterla usare nel componente
    const { currentLang, currentCountry } = useLanguageSupport();
    const showColumns = computed(() => {
      //context.slots.columns => funziona solo se lo slot è veramente vuoto.
      //Se nello slot dobbiamo renderizzare condizionalmente un contenuto, il check non ritorna undefined ma ritorna un array di oggetti contenenti i contenuti condizionali, quindi dobbiamo controllare anche se la proprietà type di questo oggetto non è Symbol(Comment) per un check completo!
      return (
        context.slots.columns &&
        context.slots.columns().findIndex((o) => o.type !== Comment) !== -1
      );
    });
    const showLegalText = computed(() => {
      return (
        context.slots.legalText &&
        context.slots.legalText().findIndex((o) => o.type !== Comment) !== -1
      );
    });
    function onBtnLangClick() {
      console.log('modal not implemented')
    }
    return {
      step,
      theme,
      currentLang,
      currentCountry,
      onBtnLangClick,
      showColumns,
      showLegalText,
    };
  }
};
</script>

<style lang="scss" scoped>
@import "../scss/_variables.scss";
@import "~bootstrap/scss/mixins/breakpoints";

.WaFooter {
  background-color: $color-grey-4;
  color: $color-blue-logo;

  :deep(.topFooter) {
    margin-bottom: 28px;

    nav {
      ul {
        display: block;
        list-style: none;
        margin-top: 0px;
        padding-left: 0px;
        margin-block-start: 0px;
        margin-block-end: 0px;
        margin-inline-start: 0px;
        margin-inline-end: 0px;
        padding-inline-start: 0px;
      }

      li {
        margin-bottom: 32px;
      }
    }

    .navigationColumns {
      .WaFooterCol:nth-child(n + 3) {
        @media (min-width: $bootstrap-xs) {
          margin-top: 32px;
        }

        @media (min-width: $bootstrap-sm) {
          margin-top: 0px;
        }
      }
    }

    .navbarLanguage {
      margin-top: 59px;
      cursor: pointer;

      @media (min-width: $bootstrap-sm) {
        margin-top: 0px;
      }
    }
  }

  .bottomFooter {
    @media (min-width: $bootstrap-sm) {
      display: flex;
      justify-content: space-between;
      flex-wrap: wrap;
    }

    @include media-breakpoint-up(md) {
      flex-flow: row-reverse;
      align-items: center;
    }

    :deep(.WaSocialShare) {
      @include media-breakpoint-down(xs) {
        margin-bottom: 32px;
        margin-top: 28px;
        text-align: center;
        justify-content: center;
      }

      @include media-breakpoint-up(sm) {
        flex: 0 0 50%;
        justify-content: flex-end;
      }
    }

    :deep(.WaSocialShareItem) {
      @include media-breakpoint-up(xs) {
        justify-content: center;
      }

      //&:hover {
      //  color: $color-cobalt-blue;
      //}
    }

    :deep(.copyrightFooter) {
      color: $color-grey-8;
      text-align: center;
      //flex: 100%;

      @include media-breakpoint-up(sm) {
        margin-top: 40px;
        text-align: left;
        flex: 100%;
      }

      @include media-breakpoint-up(md) {
        margin-top: 0;
      }

      //@media (min-width: $bootstrap-sm) {
      //  margin-top: 40px;
      //}
      //
      //@media (min-width: $bootstrap-md) {
      //  text-align: left;
      //  flex: 0 50%;
      //  margin-top: 0px;
      //}
      //
      //@media (min-width: $bootstrap-lg) {
      //  text-align: left;
      //}

      p {
        margin-bottom: 0;
      }
    }

    .navbarLanguage {
      text-align: center;
      cursor: pointer;

      @include media-breakpoint-up(sm) {
        display: flex;
        flex: 0 0 50%;
        align-items: center;
      }

      // flex: 0 50%;

      // @media (min-width: $bootstrap-sm) {
      //   text-align: left;

      // }
    }
  }

  .currentLangItem {
    color: $color-blue-logo;
    text-decoration: underline;
    display: inline-block;
    padding-right: 8px;
  }

  &.bg-color-blue-logo {
    background-color: $color-blue-logo;
    color: #ffffff;

    .currentLangItem {
      color: $color-white;
      text-decoration: underline;
      display: inline-block;
      padding-right: 8px;
    }

    .socialIconsFooter {
      .socialIcon {
        color: #ffffff;
      }
    }

    .copyrightFooter {
      color: $color-grey-4;
    }
  }
}
</style>
